/****************************************************************/
/*  main.h 														*/
/*																*/
/*																*/
/*																*/
/*	written by Wolfgang Weirczeyko	Mrz 2008					*/
/*																*/
/*																*/
/*																*/
/*																*/
/****************************************************************/





#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>
#include <avr/pgmspace.h>
#include <math.h>

#include "ledctrl.h"
#include "timer0.h"
#include "uart.h"
#include "Datenhandling.h"

#define F_OSC 14756000       /* Taktfrequenz 14.756 MHz interner Takt */
#define USART_BAUD  (F_OSC/38400/8)-1 /* 54,700kBaud mit U2X*/ 

/* Vertrglichkeit mit neuem Compiler */

#define sbi(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define cbi(ADDRESS,BIT) ((ADDRESS) &= ~(1<<(BIT)))
#define outp(VAL,ADRESS) ((ADRESS) = (VAL))

#define RXB_LEN_0  150
#define	ROT	PD3
#define	ROT_ON		sbi(PORTD,3) 
#define	ROT_OFF		cbi(PORTD,3)
#define GRUEN_ON  	sbi(PORTD,2)
#define GRUEN_OFF  	cbi(PORTD,2)

extern volatile uint8_t		MSEC1000;
extern volatile uint8_t		MSEC100;
extern volatile uint8_t		MSEC10;
extern volatile uint8_t		Tackt;

extern volatile unsigned char RX_BUFF_0[RXB_LEN_0];
extern volatile unsigned char rx_poi_0;
extern volatile unsigned char ds_komplett_0;
extern volatile unsigned char r_on;
extern volatile unsigned char r_blink; 
extern volatile unsigned char g_on;
extern volatile unsigned char g_blink;
