/****************************************************************/
/*  uart.c 														*/
/*																*/
/*	handelt die beiden Schnittstellen							*/
/*																*/
/*	written by Wolfgang Weirczeyko	Mrz 2008					*/
/*																*/
/*	uart0 == Daten von der FC									*/			
/*	uart1 == Daten zum PC										*/
/****************************************************************/

#include "main.h"

unsigned char s_temp;
unsigned char umode0 = 0;

void init_uarts(void)
{

	
	UBRR0L = (uint8_t)47;		/* Baudrate auf 56,7		*/
	UBRR0H = (uint8_t)0;		/*    """"""				*/
	UBRR1L = (uint8_t)47;		/*    """"""				*/
	UBRR1H = (uint8_t)0;		/*    """"""				*/


	 						
	PORTD |= _BV(PD0); //Pullup aktivieren					

	UCSR0B  = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0); 	/* enable RX, TX, interrupt RX */
	UCSR0C  = (1<<URSEL0)|(1<<UCSZ01) | (1<<UCSZ00);/* 8 Data, No parity, 1 Stop  	*/
	UCSR0A  = (1 << RXC0) | (1 << TXC0) | (1 << U2X0);

	UCSR1B  = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0); 	/* enable RX, TX, interrupt RX */
	UCSR1C  = (1<<URSEL0)|(1<<UCSZ01) | (1<<UCSZ00);/* 8 Data, No parity, 1 Stop  	*/
	UCSR1A  = (1 << RXC0) | (1 << TXC0) | (1 << U2X0);
}


SIGNAL(SIG_USART0_RECV)  				/* Byte auf USART0 ist da */
{

	s_temp = UDR0;  					/* Byte holen.	*/

	if ( (s_temp == '\r') && ( umode0 = 2 )) /* Endezeichen und Mode == 2 */
	{	
		ROT_OFF;
		umode0 = 0; 					/* Neuer datensatz kommt gleich */
		ds_komplett_0 = 1 ;				/* Datensatz 0 ist da und kann verarbeitet werden.*/
		RX_BUFF_0[rx_poi_0] = s_temp;	/* Speichern im Buffer */ 
		ds_komplett_0 =1;				/* Neuer Datensatz da kann verarbeitet werden */
	}
	else
	switch(umode0)
	{

		case 0:
			if ( (s_temp == '#') && ( !ds_komplett_0)) 	/* Startzeichen und Dazten schon verarbeitet */
			{
				umode0 = 1;								/* Modus Datensammeln */
				ROT_ON;
			}
			rx_poi_0 = 0;					/* Pointer auf Null setzten. Neuer Datensatz */
										
			RX_BUFF_0[rx_poi_0++] = s_temp;	/* Byte in den Buffer */
			break;
		case 1: 		/* Daten sammeln */
			RX_BUFF_0[rx_poi_0] = s_temp;	/* Byte in den Buffer */

			if ( rx_poi_0 < RXB_LEN_0)		/* Buffer voll dann abbruch */
				rx_poi_0++;
			else
				umode0 = 0;					/* Fange von vorne an */
			break;

	}	

}
